# -- test metapackages ------
## vim: ft=yaml
{#
This Jinja2 template is rendered to generate a dynamic child pipeline
to test each metapackage in isolation.

The generate.py script supports many more platforms and distributions
than we support in CI; the 'supported' array below defines what
(platform, distribution) pairs are actually configured to run during
the test stage.

There is then template logic below to only render a
<platform>_test_<dist>ribution job for the ones supported in CI.
-#}

{%- set supported = {
    'debian': [
        'bullseye',
        'bookworm',
    ],
    'redhat': [
        'el8',
        'el9',
    ],
}-%}

default:
  # all jobs can be interrupted
  interruptible: true
  # retry all jobs at most twice when gitlab-ci fails to start the job properly
  # see https://git.ligo.org/help/ci/yaml/#retry
  retry:
    max: 2
    when:
      - runner_system_failure

include:
  - component: git.ligo.org/computing/gitlab/components/debian/test@2
    inputs:
      stage: &test_stage test
      debian_versions: {{ supported['debian'] }}
      build_prefix: "debian_build"
      job_prefix: ".debian_test"
      test_install: &test_install >-
        bash
        ${METAPACKAGE}

  - component: git.ligo.org/computing/gitlab/components/redhat/test@2
    inputs:
      stage: *test_stage
      redhat_versions: {{ supported['redhat'] }}
      build_prefix: "redhat_build"
      job_prefix: ".redhat_test"
      test_install: *test_install

{% for dist in metapackages -%}
{%- if dist in supported['debian'] -%}
{%- set platform = 'debian' -%}
{%- elif dist in supported['redhat'] -%}
{%- set platform = 'redhat' -%}
{%- else -%}
{%- set platform = 'skip' -%}
{%- endif %}
{%- if platform != 'skip' -%}
{{ platform }}_test_{{ dist }}:
  extends: .{{ platform }}_test_{{ dist }}
  variables:
    GIT_STRATEGY: fetch
    GIT_DEPTH: 1
  parallel:
    matrix:
      - METAPACKAGE:
          {%- for meta in metapackages[dist] %}
          - {{ meta }}
          {%- endfor %}
  needs:
    - pipeline: $PARENT_PIPELINE_ID
      job: generate
    - pipeline: $PARENT_PIPELINE_ID
      job: {{ platform }}_build_{{ dist }}
  script:
    - bash tools/test-runner.sh ${METAPACKAGE} stage/${METAPACKAGE}/{{ dist }}/test.sh
  artifacts:
    reports:
      junit: junit*.xml
{% endif %}
{% endfor %}
